clear all

cd "/Users/sangraekim/Dropbox/project/wholesale bank macro model/empirical/imoneynet/data/"

use "imoneynet/barclays_merged_monthly"

append using "imoneynet/bmo_merged_monthly",force
append using "imoneynet/bns_merged_monthly",force
append using "imoneynet/boa_merged_monthly",force
append using "imoneynet/citi_merged_monthly",force
append using "imoneynet/cs_merged_monthly",force
append using "imoneynet/db_merged_monthly",force
append using "imoneynet/goldman_merged_monthly",force
append using "imoneynet/hsbc_merged_monthly",force
append using "imoneynet/jpm_merged_monthly",force
append using "imoneynet/ms_merged_monthly",force
append using "imoneynet/td_merged_monthly",force
append using "imoneynet/ubs_merged_monthly",force
append using "imoneynet/wf_merged_monthly",force



gen month = month(date2)

drop _merge


encode securityissuer, gen(issuer_id)
encode securitytype, gen(type_id)





gen consecutive = .
sort securityissuer imoneynetfundcode yq_issue
by securityissuer imoneynetfundcode: replace consecutive = 1 if yq_issue - yq_issue[_n-1] == 1


gen run = 1 if (value - value_lag)/value_lag < 0
replace run = 0 if run == .


egen aaaaa = mean(roe)
egen aaaa = sd(roe)
gen roe_standard = (roe - aaaaa)/aaaa
drop aaaaa aaaa 


egen aaaaa = mean(roe_lag)
egen aaaa = sd(roe_lag)
gen roe_lag_standard = (roe_lag - aaaaa)/aaaa
drop aaaaa aaaa 

egen aaaaa = mean(roe_lag2)
egen aaaa = sd(roe_lag2)
gen roe_lag_2_standard = (roe_lag2 - aaaaa)/aaaa
drop aaaaa aaaa 


egen aaaaa = mean(req)
egen aaaa = sd(req)
gen req_standard = (req - aaaaa)/aaaa
drop aaaaa aaaa 

egen aaaaa = mean(value)
egen aaaa = sd(value)
gen value_standard = (value - aaaaa)/aaaa
drop aaaaa aaaa 


egen aaaa = mean(niq_lag)
egen aaaaa = sd(niq_lag)
gen niq_standard = (niq_lag - aaaa)/aaaaa
drop aaaa aaaaa

egen aaaa = mean(teqq_lag)
egen aaaaa = sd(teqq_lag)
gen teqq_standard = (teqq_lag - aaaa)/aaaaa
drop aaaa aaaaa

egen aaaa = mean(niq_lag2)
egen aaaaa = sd(niq_lag2)
gen niq_standard2 = (niq_lag2 - aaaa)/aaaaa
drop aaaa aaaaa

egen aaaa = mean(teqq_lag2)
egen aaaaa = sd(teqq_lag2)
gen teqq_standard2 = (teqq_lag2 - aaaa)/aaaaa
drop aaaa aaaaa





gen roe_req = roe_standard*req_standard


gen log_atq = ln(atq)
gen log_cheq = ln(cheq)
gen log_ltq = ln(ltq)
gen log_sale = ln(saleq)
gen log_req = ln(req)

gen log_roe_sale = ln(roe/saleq)
gen log_atq_sale = ln(atq/saleq)
gen log_cheq_sale = ln(cheq/saleq)
gen log_ltq_sale = ln(ltq/saleq)

gen roe_sale = roe/saleq
gen atq_sale = atq/saleq
gen cheq_sale = cheq/saleq
gen ltq_sale = ltq/saleq


replace roe = roe*100
gen log_1roe = ln(1+(roe/100))
gen log_1roe_lag = ln(1+(roe_lag/100))

egen aaa = min(roe)
gen log_roe2 = ln(roe - aaa + 1)
drop aaa


sort issuer_id yq_issue


merge m:1 ym_issue using "tbill/tbill_monthly"
drop _merge


merge m:1 yq_issue securityissuer using "ceo_change"
drop _merge
replace ceo_change = 0 if ceo_change == .

 merge m:1 yq_issue securityissuer using "ceo_change_lag"
 drop _merge
 replace ceo_change_lag = 0 if ceo_change_lag == .

 merge m:1 yq_issue securityissuer using "ceo_change_lead"
 drop _merge
 replace ceo_change_lead = 0 if ceo_change_lead == .
 
  merge m:1 ym_issue securityissuer using "data_cds"
 drop _merge
 
  merge m:1 ym_issue securityissuer using "data_implied_vol"
 drop _merge
 rename vol vol_implied
 
   merge m:1 ym_issue securityissuer using "data_realized_vol"
 drop _merge
 rename vol vol_realized
 
    merge m:1 yq_issue using "gdp"
 drop _merge



gen spread_tbill = .
replace spread_tbill = yield1 - fedfundsrate if maturity1 == 1
replace spread_tbill = yield1 - t_1m + (t_3m - t_1m)*maturity1/(89-1) if maturity1 >= 2 & maturity1 <= 89
replace spread_tbill = yield1 - t_3m + (t_1y - t_3m)*maturity1/(364-90) if maturity1 >= 90 & maturity1 <=364
replace spread_tbill = yield1 - t_1y + (t_3y - t_1y)*maturity1/(1094 - 365) if maturity1 >= 365 & maturity1 <= 1094
replace spread_tbill = yield1 - t_3y if maturity1 >= 1095





sort  imoneynetfundcode securityissuer ym_issue
by imoneynetfundcode securityissuer: gen spread_growth = (spread_tbill - spread_tbill[_n-1])/spread_tbill[_n-1]
by imoneynetfundcode securityissuer: gen spread_change = spread_tbill[_n] - spread_tbill[_n - 1]



*gen log_spread = ln(spread)*/

egen aaaa = mean(spread_tbill)
egen aaaaa = sd(spread_tbill)
gen spread_standard = (spread_tbill - aaaa)/aaaaa
drop aaaa aaaaa


gen req_atq = req/atq
gen cheq_atq = cheq/atq
gen ltq_atq = ltq/atq

gen req_atq_lag = req_lag/atq_lag
gen cheq_atq_lag = cheq_lag/atq_lag



label variable log_atq  "log(Assets)"
label variable log_cheq  "log(Cash/Short-term Assets)"
label variable log_ltq  "log(Liabilities)"
label variable log_roe  "log(Return on Equity)"
*label variable log_spread "log(Spread)"

label variable roe_standard "ROE Standardized"
label variable spread_standard "Spread Standardized"

label variable roe_lag "ROE"
label variable cheq_atq_lag "Cash/Asset"
label variable req_atq_lag "Retained Earning/Asset"
label variable spread_tbill "Spread"

gen log_roegrowth = ln(1+roe_growth)
gen log_vol_implied = ln(vol_implied)
gen log_vol_realized = ln(vol_realized)





gen year = year(date2)


drop if lineitem ==.


reg pllq npa_lead npa npa_lag ,r
predict aa, residual
gen aaa = abs(aa)
egen ss = mean(aaa)
egen sss = sd(aaa)
gen opacity = (aaa - ss)/sss
drop aa

egen aa = median(aaa)
gen opacity1 = 0 if aaa != .
replace opacity1 = 1 if aaa > aa & aaa != .
drop aa aaa ss sss

gen log_roeXopacity = log_1roe*opacity
gen log_roeXopacity1 = log_1roe*opacity1

gen roeXopacity = roe*opacity
gen roeXopacity1 = roe*opacity1

gen roe_lagXopacity = roe_lag*opacity
gen roe_lagXopacity1 = roe_lag*opacity1

gen ratio_lagXopacity = ratio_lag*opacity
gen ratio_lagXopacity1 = ratio_lag*opacity1

save data,replace



forval y = 619/743 {
use data, clear
qui keep if ym_issue1==`y'
AWshock fund_id1 securityissuer value value_lag

if `y'==619 {
save data_temp, replace 
}

if `y'~=619 { 
	append using data_temp 
	save data_temp, replace
}
}

rename At_dot bank_shock
rename Bt_dot fund_shock


save data, replace
erase data_temp.dta
